<?php
include('errorhandling.php');

include('config.php');
include('database.php');
include('helpers.php');

$payload = json_decode($_POST['payload'], TRUE);

db_connect();

date_default_timezone_set("America/New_York");

$redis = new Redis();
$redis->connect($GLOBALS['config']['redis']['host']);
$redis->auth($GLOBALS['config']['redis']['password']);

// Just use the first event for redis. Currently redis is just used for various
// counts of unique UUIDs, so no reason to re-insert for every event.

$event = $payload[0];
$os = $event['platform']['os'];
$beta = $event['release']['beta'];
$uuid = $event['platform']['id'];
$tablet = $event['platform']['tablet'];

$key = $os;
if ($beta) $key .= "_beta";
if ($os == "android" AND $tablet) $key .= "_tablet";

// Generates keys like iphone_beta or android_beta_tablet or android, then we
// do SCARD or SINTER on these sets with Redis

$redis->sAdd($key, $uuid);

foreach ($payload as $event) {

  $date = strtotime($event['date']);
  $debug = $event['release']['debug'];
  $beta = $event['release']['beta'];
  $version = $event['release']['version'];
  $api = $event['release']['api'];
  $name = 'event';
  if (isset($event['name'])) $name = $event['name']; 
  $handle = $event['handle'];
  $type = $event['type'];

  $role = $event['role'];
  $campus = $event['campus'];

  $os = $event['platform']['os'];
  $osversion = $event['platform']['version'];
  $model = $event['platform']['model'];
  $tablet = $event['platform']['tablet'];
  $androidversion = $event['platform']['android'];
  $uuid = $event['platform']['id'];
  $dpi = $event['platform']['dpi'];
  $diag = $event['platform']['diag'];

  $blob = json_encode($event);

  // insert into mysql

  db_query(
    'INSERT INTO ' .
    'analytics (' .
      'date, debug, beta, version, api, name, handle, type, `blob`, ' .
      'os, osversion, model, tablet, androidversion, uuid, dpi, diag, ' . 
      'role, campus) ' .
    'VALUES (FROM_UNIXTIME(%s), "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", ' .
      '"%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s", "%s");',
    $date, $debug, $beta, $version, $api, $name, $handle, $type, $blob,
    $os, $osversion, $model, $tablet, $androidversion, $uuid, $dpi, $diag,
    $role, $campus
  );

}

?>
